﻿using HarmonyLib;
using System.Collections;
using System.Linq;
using System.Reflection;
using UnityEngine;
using UnityEngine.UI;

public class OldBreathMeter : Mod
{

    AssetBundle bundle;
    public static GameObject oxygenCanvas;
    public static Image bar;
    Harmony HARMONY_INSTANCE;
    string HARMONY_ID = "fr.tekgamer.oldbreathmeter";
    public static OldBreathMeter instance;

    IEnumerator Start()
    {
        instance = this;
        EnsureBundleUnload("oldoxygen.assets");
        var bundleLoadRequest = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("oldoxygen.assets"));
        yield return bundleLoadRequest;
        bundle = bundleLoadRequest.assetBundle;
        oxygenCanvas = Instantiate(bundle.LoadAsset<GameObject>("OxygenCanvas"), Vector3.zero, Quaternion.identity, transform);
        oxygenCanvas.SetActive(false);
        bar = oxygenCanvas.transform.Find("OxygenMeter").Find("Foreground").GetComponent<Image>();
        HARMONY_INSTANCE = new Harmony(HARMONY_ID);
        HARMONY_INSTANCE.PatchAll(Assembly.GetExecutingAssembly());
    }

    public void Update()
    {
        CanvasHelper helper = ComponentManager<CanvasHelper>.Value;
        if (helper)
        {
            if (helper.fatigueParent != null && helper.fatigueParent.name == "OxygenMeter")
            {
                GameObject original = helper.fatigueParent;
                helper.fatigueParent = oxygenCanvas;
                helper.fatigueBackground = oxygenCanvas.transform.Find("OxygenMeter").Find("Background").GetComponent<Image>();
                helper.fatigueRadial = oxygenCanvas.transform.Find("OxygenMeter").Find("Foreground").GetComponent<Image>();
                helper.fatigueParent.SetActive(original.activeSelf);
                original.SetActive(false);
            }
        }
    }

    public static void EnsureBundleUnload(string name)
    {
        AssetBundle.GetAllLoadedAssetBundles().ToList().ForEach(assetbundle =>
        {
            if (assetbundle.name == name)
            {
                assetbundle.Unload(true);
            }
        });
    }

    public static void DefaultBreathMeter()
    {
        CanvasHelper helper = ComponentManager<CanvasHelper>.Value;
        if (helper)
        {
            if (helper.fatigueParent == null || helper.fatigueParent.name != "OxygenMeter")
            {
                helper.fatigueParent = helper.transform.Find("OxygenMeter").gameObject;
                helper.fatigueBackground = helper.transform.Find("OxygenMeter").Find("Background").GetComponent<Image>();
                helper.fatigueRadial = helper.transform.Find("OxygenMeter").Find("Background").Find("Foreground").GetComponent<Image>();
            }
        }
    }

    public static void Unload()
    {
        DefaultBreathMeter();
        EnsureBundleUnload("oldoxygen.assets");
        Debug.Log("Mod OldBreathMeter has been unloaded!");
    }

    public void OnModUnload()
    {
        HARMONY_INSTANCE.UnpatchAll(HARMONY_ID);
        Unload();
    }
}

[HarmonyPatch(typeof(CanvasHelper))]
[HarmonyPatch("SetFatigueSlider")]
class Patch_CanvasFatigue
{
    static void Postfix(CanvasHelper __instance, float value)
    {
        if (OldBreathMeter.instance != null && OldBreathMeter.oxygenCanvas != null && OldBreathMeter.bar != null)
        {
            float v = 1 - (value + Random.Range(0, 0.2f));
            Color color = new Color(1, 1 - v, 1 - v);
            if(value <= 0.3f)
            {
                float rnd = Random.Range(0.2f, 0.4f);
                color = new Color(color.r+rnd, color.g + rnd, color.b + rnd);
            }
            OldBreathMeter.bar.color = color;
            __instance.fatigueRadial.fillAmount = 1 - value;
        }
    }
}